# -*- coding: utf-8 -*-
#Boa:Dialog:langSelect

"""
Copyright (C) 2005-2008 Ianaré Sévi

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

ianare@gmail.com
"""

import wx

def create(parent, Title, event):
    return langSelect(parent, Title, event)

[wxID_LANGSELECT, wxID_LANGSELECTDE, wxID_LANGSELECTEN_UK, wxID_LANGSELECTES,
 wxID_LANGSELECTFR, wxID_LANGSELECTHU, wxID_LANGSELECTJA, wxID_LANGSELECTPL,
 wxID_LANGSELECTPT_BR, wxID_LANGSELECTTR, wxID_LANGSELECTEN_US, wxID_LANGSELECTRU,
 wxID_LANGSELECTZH_CN, wxID_LANGSELECTAR, wxID_LANGSELECTHE, wxID_LANGSELECTEL,
 wxID_LANGSELECTSV, wxID_LANGSELECTAR, wxID_LANGSELECTNL, wxID_LANGSELECTIT,
 wxID_LANGSELECTKO
] = [wx.NewId() for _init_ctrls in range(21)]

class langSelect(wx.Dialog):
    def Sizer(self):
        optionsSizer = wx.FlexGridSizer(cols=2, hgap=3, vgap=10)
        optionsSizer.Add(self.arFlag,0, wx.ALIGN_CENTRE)
        optionsSizer.Add(self.ar)
        optionsSizer.Add(self.deFlag,0, wx.ALIGN_CENTRE)
        optionsSizer.Add(self.de)
        optionsSizer.Add(self.elFlag,0, wx.ALIGN_CENTRE)
        optionsSizer.Add(self.el)
        optionsSizer.Add(self.enFlag,0, wx.ALIGN_CENTRE)
        optionsSizer.Add(self.en_US)
        #optionsSizer.Add(self.en_ukFlag,0, wx.ALIGN_CENTRE)
        #optionsSizer.Add(self.en_GB)
        optionsSizer.Add(self.esFlag,0, wx.ALIGN_CENTRE)
        optionsSizer.Add(self.es)
        optionsSizer.Add(self.frFlag,0, wx.ALIGN_CENTRE)
        optionsSizer.Add(self.fr)
        #optionsSizer.Add(self.heFlag,0, wx.ALIGN_CENTRE)
        #optionsSizer.Add(self.he)
        optionsSizer.Add(self.huFlag,0, wx.ALIGN_CENTRE)
        optionsSizer.Add(self.hu)
        optionsSizer.Add(self.itFlag,0, wx.ALIGN_CENTRE)
        optionsSizer.Add(self.it)
        optionsSizer.Add(self.jaFlag,0, wx.ALIGN_CENTRE)
        optionsSizer.Add(self.ja)
        optionsSizer.Add(self.koFlag,0, wx.ALIGN_CENTRE)
        optionsSizer.Add(self.ko)
        optionsSizer.Add(self.nlFlag,0, wx.ALIGN_CENTRE)
        optionsSizer.Add(self.nl)
        optionsSizer.Add(self.plFlag,0, wx.ALIGN_CENTRE)
        optionsSizer.Add(self.pl)
        optionsSizer.Add(self.pt_BRFlag,0, wx.ALIGN_CENTRE)
        optionsSizer.Add(self.pt_BR)
        optionsSizer.Add(self.ruFlag,0, wx.ALIGN_CENTRE)
        optionsSizer.Add(self.ru)
        optionsSizer.Add(self.svFlag,0, wx.ALIGN_CENTRE)
        optionsSizer.Add(self.sv)
        optionsSizer.Add(self.trFlag,0, wx.ALIGN_CENTRE)
        optionsSizer.Add(self.tr)
        optionsSizer.Add(self.zh_CNFlag,0, wx.ALIGN_CENTRE)
        optionsSizer.Add(self.zh_CN)

        buttonsSizer = wx.BoxSizer(wx.HORIZONTAL)
        buttonsSizer.Add(self.ok,0,wx.RIGHT|wx.LEFT,5)
        buttonsSizer.Add(self.cancel,0,wx.RIGHT,5)

        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(optionsSizer,0,wx.ALIGN_CENTRE|wx.ALL,10)
        sizer.Add(buttonsSizer,0,wx.BOTTOM|wx.TOP,5)

        self.SetSizerAndFit(sizer)

    def _init_ctrls(self, prnt, Title):
        # generated method, don't edit
        wx.Dialog.__init__(self, id=wxID_LANGSELECT, name=u'langSelect',
              parent=prnt, size=wx.Size(281, 292),
              style=wx.DEFAULT_DIALOG_STYLE, title=Title)
        self.SetIcon(wx.Icon(prnt.realPath(u'icons/metamorphose.ico'), wx.BITMAP_TYPE_ICO))

        self.ar = wx.RadioButton(id=wxID_LANGSELECTAR, label=u'العربية',
              name=u'ar', parent=self, style=wx.RB_GROUP)
        self.ar.SetToolTipString(u"العربية (ar)")
        self.arFlag = wx.StaticBitmap(parent=self, id=-1,
              bitmap=wx.Bitmap(prnt.realPath(u'icons/flags/ar.png'),
              wx.BITMAP_TYPE_PNG))

        self.de = wx.RadioButton(id=wxID_LANGSELECTDE, label=u'Deutsch',
              name=u'de', parent=self, style=0)
        self.de.SetToolTipString(u"Deutsch (de)")
        self.deFlag = wx.StaticBitmap(parent=self, id=-1,
              bitmap=wx.Bitmap(prnt.realPath(u'icons/flags/de.png'),
              wx.BITMAP_TYPE_PNG))

        self.el = wx.RadioButton(id=wxID_LANGSELECTEL, label=u'Ελληνικά',
              name=u'el', parent=self, style=0)
        self.el.SetToolTipString(u"Ελληνικά (el)")
        self.elFlag = wx.StaticBitmap(parent=self, id=-1,
              bitmap=wx.Bitmap(prnt.realPath(u'icons/flags/gr.png'),
              wx.BITMAP_TYPE_PNG))

        self.en_US = wx.RadioButton(id=wxID_LANGSELECTEN_US, label=u'English',
              name=u'en_US', parent=self, style=0)
        self.en_US.SetToolTipString(u"American English (en_US)")
        self.enFlag = wx.StaticBitmap(parent=self, id=-1,
              bitmap=wx.Bitmap(prnt.realPath(u'icons/flags/us.png'),
              wx.BITMAP_TYPE_PNG))

        """
        self.en_UK = wx.RadioButton(id=wxID_LANGSELECTEN_UK, label=u'English',
              name=u'en_UK', parent=self, style=0)
        self.en_UK.SetToolTipString(u"English (en_UK)")
        self.en_ukFlag = wx.StaticBitmap(parent=self, id=-1,
              bitmap=wx.Bitmap(prnt.realPath(u'icons/flags/uk.png'),
              wx.BITMAP_TYPE_PNG))
        """
        self.es = wx.RadioButton(id=wxID_LANGSELECTES, label=u'Español',
              name=u'es', parent=self, style=0)
        self.es.SetToolTipString(u"Español (es)")
        self.esFlag = wx.StaticBitmap(parent=self, id=-1,
              bitmap=wx.Bitmap(prnt.realPath(u'icons/flags/es.png'),
              wx.BITMAP_TYPE_PNG))

        self.fr = wx.RadioButton(id=wxID_LANGSELECTFR, label=u'Français',
              name=u'fr', parent=self, style=0)
        self.fr.SetToolTipString(u"Français (fr)")
        self.frFlag = wx.StaticBitmap(parent=self, id=-1,
              bitmap=wx.Bitmap(prnt.realPath(u'icons/flags/fr.png'),
              wx.BITMAP_TYPE_PNG))
        """
        self.he = wx.RadioButton(id=wxID_LANGSELECTHE, label=u'עברית',
              name=u'he', parent=self, style=0)
        self.he.SetToolTipString(u"עברית (he)")
        self.heFlag = wx.StaticBitmap(parent=self, id=-1,
              bitmap=wx.Bitmap(prnt.realPath(u'icons/flags/il.png'),
              wx.BITMAP_TYPE_PNG))
        """
        self.hu = wx.RadioButton(id=wxID_LANGSELECTHU, label=u'Magyar',
              name=u'hu', parent=self, style=0)
        self.hu.SetToolTipString(u"Magyar (hu)")
        self.huFlag = wx.StaticBitmap(parent=self, id=-1,
              bitmap=wx.Bitmap(prnt.realPath(u'icons/flags/hu.png'),
              wx.BITMAP_TYPE_PNG))

        self.it = wx.RadioButton(id=wxID_LANGSELECTIT, label=u'Italiano',
              name=u'it', parent=self, style=0)
        self.it.SetToolTipString(u"Italiano (it)")
        self.itFlag = wx.StaticBitmap(parent=self, id=-1,
              bitmap=wx.Bitmap(prnt.realPath(u'icons/flags/it.png'),
              wx.BITMAP_TYPE_PNG))

        self.ja = wx.RadioButton(id=wxID_LANGSELECTJA, label=u'日本語',
              name=u'ja', parent=self, style=0)
        self.ja.SetToolTipString(u"日本語 (ja)")
        self.jaFlag = wx.StaticBitmap(parent=self, id=-1,
              bitmap=wx.Bitmap(prnt.realPath(u'icons/flags/ja.png'),
              wx.BITMAP_TYPE_PNG))
      
        self.ko = wx.RadioButton(id=wxID_LANGSELECTKO, label=u'한국어',
              name=u'ko', parent=self, style=0)
        self.ko.SetToolTipString(u"한국어  (ko)")
        self.koFlag = wx.StaticBitmap(parent=self, id=-1,
              bitmap=wx.Bitmap(prnt.realPath(u'icons/flags/kr.png'),
              wx.BITMAP_TYPE_PNG))

        self.nl = wx.RadioButton(id=wxID_LANGSELECTNL, label=u'Nederlands',
              name=u'nl', parent=self, style=0)
        self.nl.SetToolTipString(u"Nederlands (nl)")
        self.nlFlag = wx.StaticBitmap(parent=self, id=-1,
              bitmap=wx.Bitmap(prnt.realPath(u'icons/flags/nl.png'),
              wx.BITMAP_TYPE_PNG))

        self.pl = wx.RadioButton(id=wxID_LANGSELECTPL, label=u'Polski',
              name=u'pl', parent=self, style=0)
        self.pl.SetToolTipString(u"Polski (pl)")
        self.plFlag = wx.StaticBitmap(parent=self, id=-1,
              bitmap=wx.Bitmap(prnt.realPath(u'icons/flags/pl.png'),
              wx.BITMAP_TYPE_PNG))

        self.pt_BR = wx.RadioButton(id=wxID_LANGSELECTPT_BR, label=u'Português',
              name=u'pt_BR', parent=self, style=0)
        self.pt_BR.SetToolTipString(u"Português do Brasil (pt_BR)")
        self.pt_BRFlag = wx.StaticBitmap(parent=self, id=-1,
              bitmap=wx.Bitmap(prnt.realPath(u'icons/flags/br.png'),
              wx.BITMAP_TYPE_PNG))

        self.tr = wx.RadioButton(id=wxID_LANGSELECTTR, label=u'Türkçe',
              name=u'tr', parent=self, style=0)
        self.tr.SetToolTipString(u"Türkçe (tr)")
        self.trFlag = wx.StaticBitmap(parent=self, id=-1,
              bitmap=wx.Bitmap(prnt.realPath(u'icons/flags/tr.png'),
              wx.BITMAP_TYPE_PNG))

        self.ru = wx.RadioButton(id=wxID_LANGSELECTRU, label=u'Русский',
              name=u'ru', parent=self, style=0)
        self.ru.SetToolTipString(u"Русский (ru)")
        self.ruFlag = wx.StaticBitmap(parent=self, id=-1,
              bitmap=wx.Bitmap(prnt.realPath(u'icons/flags/ru.png'),
              wx.BITMAP_TYPE_PNG))

        self.sv = wx.RadioButton(id=wxID_LANGSELECTSV, label=u'Svenska',
              name=u'sv', parent=self, style=0)
        self.sv.SetToolTipString(u"Svenska (sv)")
        self.svFlag = wx.StaticBitmap(parent=self, id=-1,
              bitmap=wx.Bitmap(prnt.realPath(u'icons/flags/se.png'),
              wx.BITMAP_TYPE_PNG))

        self.zh_CN = wx.RadioButton(id=wxID_LANGSELECTZH_CN, label=u'中文',
              name=u'zh_CN', parent=self, style=0)
        self.zh_CN.SetToolTipString(u"中文 (zh_CN)")
        self.zh_CNFlag = wx.StaticBitmap(parent=self, id=-1,
              bitmap=wx.Bitmap(prnt.realPath(u'icons/flags/cn.png'),
              wx.BITMAP_TYPE_PNG))

        self.ok = wx.Button(id=wx.ID_OK, name=u'ok',
              parent=self, pos=wx.Point(20, 300), style=0)

        self.cancel = wx.Button(id=wx.ID_CANCEL, name=u'cancel',
              parent=self, pos=wx.Point(120, 300), style=0)

    def __init__(self, parent, Title, event):
        self._init_ctrls(parent, Title)
        self.Sizer()
        if event:
            self.FindWindowByName(event).SetValue(True)
        else:
            self.en_US.SetValue(True)
            self.cancel.Show(False)

    def GetLanguage(self):
        notLangs = ('staticBitmap', 'ok', 'cancel')
        for child in self.GetChildren():
            name = child.GetName()
            if name not in notLangs:
                if child.GetValue():
                    return name
